#include "vcl.h"
#pragma hdrstop

#include "Defines.h"
//------------------------------------------------------------------------------
class TCSVBase
{
int iLen;
char* cBaseText;
char* lpFile;

char cNull;
HGLOBAL hMem;


bool LoadFileAndInit (char*);
char* LoadFile(char* );
int iCurrentAbonent;

public:
int iMaxNumSeparator;
int iColumn;

int* iDirectSort;
int iDirectSortNum;

char*** lpArray;
char*** lpArrayBuf;

char** lpArrayScr;
char** lpArrayDest;
char*  cMultiOAO[255];

bool bError;
bool bNewFindTextForCombo;

int iAbonents;
int iAbonentsMap;
int iAbonentsMapOAO;

bool FindInString(char* , char* );
bool CompareEnchanced(char* , char* );
bool Compare(char* , char* );
bool CompareL(char* , char* );
void CorrectHouse (char* );
void CorrectStringWithUpper(unsigned char*);
bool Find(int);
int FindAll(int);
char* FindTextForCombo();
void FindForTreeInit();
void LowToUpRus(char*);
void UpperCase(char*);
void SortArrayBuf(int, int);

TCSVBase(char* ,int );
~TCSVBase();
};
//------------------------------------------------------------------------------
bool TCSVBase::LoadFileAndInit(char* cFileName)
{
bool err=true;
if (lpFile=LoadFile(cFileName))	err=false;
else	return err;

if (!err)
        {
        iLen=lstrlen(lpFile);
        cBaseText=lpFile;
        iAbonents=1;
        while(*cBaseText++)
                {
                if (*cBaseText==10 && *(cBaseText+1))	iAbonents++;
                }
        try
                {
                lpArray=new char**[iAbonents+1];
                lpArrayBuf=new char**[iAbonents+1];
                for (int l=0; l<iAbonents+1; l++)
                        {
                        lpArray[l]=new char*[iColumn];
                        lpArrayBuf[l]=new char*[iColumn];
                        }
                }
        catch(...)
                {
                return true;
                }
        for (int l=0; l<iColumn; l++)
                for (int i=0; i<iAbonents+1; i++)
                        {
                        lpArray[i][l]=&cNull;
                        }
        char* cText=lpFile;
        bool bWrite=false;
        int iStep=0;
        int l=0;
        lpArray[0][0]=lpFile;
        while (*cText)
                {
                if (*cText==13) *cText=0;
                if (*cText==';')
                        {
                        iStep++;
                        *cText=0;
                        bWrite=true;
                        }
                if (*cText==10)
                        {
                        if (iStep>iMaxNumSeparator-1) iMaxNumSeparator=iStep+1;
                        iStep=0;
                        *cText=0;
                        bWrite=true;
                        l++;
                        }
                if (bWrite)
                        {
                        if (iStep<iColumn) lpArray[l][iStep]=cText+1;
                        bWrite=false;
                        }
                cText++;
                }
        }

return err;
}
//------------------------------------------------------------------------------
TCSVBase::TCSVBase(char* cFileName, int iCol)
{
cNull=0;
iColumn=iCol;
iMaxNumSeparator=0;
bNewFindTextForCombo=true;
if (!(bError=LoadFileAndInit(cFileName)))
        {
        lpArrayScr=new char*[iColumn];
        lpArrayDest=new char*[iColumn];
        iDirectSort=new int[iColumn+1];
        for (int i=0; i<iColumn+1; i++)
                {
                iDirectSort[i]=1;
                }
        }
}
//------------------------------------------------------------------------------
TCSVBase::~TCSVBase()
{
if (hMem!=NULL)
        {
        GlobalUnlock(hMem);
        GlobalFree(hMem);
        }
/*if (!bError)
 {
 delete[] lpArrayScr;
 delete[] lpArrayDest;
 delete[] iDirectSort;
 for (int l=0; l<iAbonents+1; l++)
  {
  delete[] lpArray[l];
  delete[] lpArrayBuf[l];
  }
 delete[] lpArray;
 delete[] lpArrayBuf;
 }*/
}
//------------------------------------------------------------------------------
void TCSVBase::CorrectHouse (char* czText)
{
char* cText=czText;
while(*cText)
        {
        if (*cText=='/'  || *cText=='.' || *cText=='\\') *cText='/';
        cText++;
        }
return;
}
//------------------------------------------------------------------------------
bool TCSVBase::Compare(char* scr, char* dest)
{
bool err=true;
unsigned char cscr, cdest;
while (*scr)
        {
        cscr=(unsigned char) *scr;
        cdest=(unsigned char) *dest;
        if (cscr>=224)  cscr-=32;
        if (cdest>=224)  cdest-=32;
        if (cscr!=cdest && cscr!='?' && cscr!='*')
                {
                err=false;
                break;
                }
        dest++;
        scr++;
        }

return err;
}
//------------------------------------------------------------------------------
bool TCSVBase::CompareL(char* scr, char* dest)
{
if (lstrlen(scr)!=lstrlen(dest))        return false;
return Compare(scr, dest);
}
//------------------------------------------------------------------------------
bool TCSVBase::Find(int iType)
{
bool err=false, going=true;
bool ff1=true;
bool ff2=true;
bool ff3=true;
bool ff4=true;
bool ff5=true;

while (going)
        {
        err=false;
        if (iCurrentAbonent>=iAbonents)
                {
                iCurrentAbonent=0;
                going=false;
                break;
                }
        switch (iType)
                {
                case SEARCH_COUNTRY_CODES2:
                        ff1=Compare(lpArrayScr[0], lpArray[iCurrentAbonent][0]);
                        ff2=Compare(lpArrayScr[1], lpArray[iCurrentAbonent][1]);
                        ff3=Compare(lpArrayScr[2], lpArray[iCurrentAbonent][2]);
                        ff4=Compare(lpArrayScr[3], lpArray[iCurrentAbonent][3]);
                        if (ff1 || ff2 || ff3 || ff4)
                                {
                                ff1=true;
                                ff2=true;
                                ff3=true;
                                ff4=true;
                                }
                        break;
                case SEARCH_COUNTRY_CODES:
                        ff1=Compare(lpArrayScr[0], lpArray[iCurrentAbonent][0]);
                        ff2=Compare(lpArrayScr[1], lpArray[iCurrentAbonent][1]);
                        ff3=Compare(lpArrayScr[2], lpArray[iCurrentAbonent][2]);
                        if (ff1 || ff2 || ff3)
                                {
                                ff1=true;
                                ff2=true;
                                ff3=true;
                                }
                        break;
                case SEARCH_OLD_CITY:
                        ff1=Compare(lpArrayScr[0], lpArray[iCurrentAbonent][0]);
                        ff2=Compare(lpArrayScr[1], lpArray[iCurrentAbonent][1]);
                        break;
                case SEARCH_VRTZ:
                        ff1=FindInString(lpArrayScr[0], lpArray[iCurrentAbonent][0]);
                        ff2=FindInString(lpArrayScr[0], lpArray[iCurrentAbonent][1]);
                        ff3=FindInString(lpArrayScr[2], lpArray[iCurrentAbonent][2]);
                        if (ff1 || ff2)
                                {
                                ff1=true;
                                ff2=true;
                                }
                        break;
                case SEARCH_OAO:
                        ff1=FindInString(lpArrayScr[0], lpArray[iCurrentAbonent][0]);
                        ff2=FindInString(lpArrayScr[0], lpArray[iCurrentAbonent][1]);
                        ff3=FindInString(lpArrayScr[2], lpArray[iCurrentAbonent][2]);
                        if (ff1 || ff2)
                                {
                                ff1=true;
                                ff2=true;
                                }
                        break;
                case SEARCH_MULTI_OAO:
                        for (int i=0; i<255 && cMultiOAO[i]!=NULL; i++)
                                {
                                ff1=FindInString(cMultiOAO[i], lpArray[iCurrentAbonent][0]);
                                ff2=FindInString(cMultiOAO[i], lpArray[iCurrentAbonent][1]);
                                if (ff1 || ff2) break;
                                }
                        ff3=FindInString(lpArrayScr[2], lpArray[iCurrentAbonent][2]);
                        if (ff1 || ff2)
                                {
                                ff1=true;
                                ff2=true;
                                }
                        break;
                case SEARCH_KGRES:
                        ff1=FindInString(lpArrayScr[0], lpArray[iCurrentAbonent][0]);
                        ff2=FindInString(lpArrayScr[0], lpArray[iCurrentAbonent][1]);
                        ff3=FindInString(lpArrayScr[2], lpArray[iCurrentAbonent][2]);
                        if (ff1 || ff2)
                                {
                                ff1=true;
                                ff2=true;
                                }
                        break;
                case SEARCH_HOME:
                        ff1=CompareEnchanced(lpArrayScr[0],lpArray[iCurrentAbonent][0]);
                        ff2=Compare(lpArrayScr[1], lpArray[iCurrentAbonent][1]);
                        ff3=Compare(lpArrayScr[2], lpArray[iCurrentAbonent][2]);
                        ff4=Compare(lpArrayScr[3], lpArray[iCurrentAbonent][3]);
                        ff5=Compare(lpArrayScr[4], lpArray[iCurrentAbonent][4]);
                        break;
                case SEARCH_CITY_CODES:
                        ff1=Compare(lpArrayScr[0], lpArray[iCurrentAbonent][0]);
                        ff3=Compare(lpArrayScr[0], lpArray[iCurrentAbonent][2]);
                        if (ff1 ||  ff3)
                                {
                                ff1=true;
                                ff3=true;
                                }
                        break;
                case SEARCH_MOBILE_CODES:
                        ff1=FindInString(lpArrayScr[0], lpArray[iCurrentAbonent][0]);
                        ff2=FindInString(lpArrayScr[0], lpArray[iCurrentAbonent][1]);
                        ff3=Compare(lpArrayScr[0], lpArray[iCurrentAbonent][2]);
                        if (ff1 ||  ff2 || ff3)
                                {
                                ff1=true;
                                ff2=true;
                                ff3=true;
                                }
                        break;
                case SEARCH_REGIONS:
                        ff3=Compare(lpArrayScr[2], lpArray[iCurrentAbonent][2]);
                        if (ff3)        ff3=true;
                        break;
                case SEARCH_KOSTROMA_CODES:
                        break;
                case SEARCH_POST_INDEXES:
                        ff1=Compare(lpArrayScr[0], lpArray[iCurrentAbonent][0]);
                        ff2=Compare(lpArrayScr[1], lpArray[iCurrentAbonent][1]);
                        if (ff1 ||  ff2)
                                {
                                ff1=true;
                                ff2=true;
                                }
                        break;
                }
        if (ff1 && ff2 && ff3 && ff4 && ff5)
                {
                 for (int i=0; i<iColumn; i++)
                        lpArrayDest[i]=lpArray[iCurrentAbonent][i];
                 going=false;
                 err=true;
                }
        iCurrentAbonent++;
        }

return err;
}
//------------------------------------------------------------------------------
int TCSVBase::FindAll(int iType)
{
int l=0;
while (Find(iType))
        {
        for (int i=0; i<iColumn; i++)
        lpArrayBuf[l][i]=lpArrayDest[i];
        l++;
        }
return l;
}

//------------------------------------------------------------------------------
void TCSVBase::CorrectStringWithUpper(unsigned char* czTextOrg)
{
unsigned char* czText=czTextOrg;
bool bCheck=false;
while (*czText++)
        {
        if (!bCheck)
                {
                if (*czText>=192 && *czText<=224)     *czText+=32;
                }
        else
                {
                bCheck=false;
                }
        if (*czText==' ' || *czText=='.' || *czText=='-') bCheck=true;
        }
return;
}
//------------------------------------------------------------------------------
char* TCSVBase::LoadFile(char* cFileName)
{

DWORD dNumRead;
DWORD dFileSize;
HANDLE hHandFile;
char* cString=0;

if ((hHandFile=CreateFile(cFileName, GENERIC_READ,FILE_SHARE_READ,
                NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, (HANDLE)NULL))!=HANDLE(-1))
        {
        if (dFileSize=GetFileSize(hHandFile,NULL))
                {
                hMem=GlobalAlloc(GPTR, dFileSize+2);
                cString=(char*) GlobalLock(hMem);
                if (dFileSize)
                        if (!ReadFile(hHandFile, cString, dFileSize, &dNumRead, NULL) || !*cString)
                                {
                                if (hMem!=NULL)
                                        {
                                        GlobalUnlock(hMem);
                                        GlobalFree(hMem);
                                        }
                                cString=0;
                                }
                }
        CloseHandle(hHandFile);
        }

return cString;
}
//------------------------------------------------------------------------------
void TCSVBase::UpperCase(char* text)
{
unsigned char* text2=text;
while(*text2)
        {
        if (*text2>=97 && *text2<=122) *text2-=32;
        if (*text2>=224) *text2-=32;
        text2++;
        }
}
//------------------------------------------------------------------------------
void TCSVBase::LowToUpRus(char* scr)
{
unsigned char* buf=(unsigned char*) scr;
while(*buf)
        {
        if (*buf>=224)  *buf-=32;
        buf++;
        }

return;
}
//------------------------------------------------------------------------------
char* TCSVBase::FindTextForCombo()
{
static int i=0;

if (bNewFindTextForCombo)
        {
        i=0;
        bNewFindTextForCombo=false;
        }
if (!i)
        {
        i++;
        return lpArray[0][0];
        }

if (i>=iAbonents) return 0;

while (!lstrcmp(lpArray[i-1][0], lpArray[i][0]))        i++;

if (i>=iAbonents) return 0;
i++;

return lpArray[i-1][0];
}
//------------------------------------------------------------------------------
bool TCSVBase::CompareEnchanced(char* scr, char* dest)
{
bool err=true;
unsigned char cscr, cdest;
while (*scr)
        {
        if (*scr=='-')
                {
                scr++;
                if (*scr==0) break;
                }
        if (*dest=='-')
                {
                dest++;
                if (*dest==0) break;
                }
        cscr=(unsigned char) *scr;
        cdest=(unsigned char) *dest;
        if (cscr>=224)  cscr-=32;
        if (cdest>=224)  cdest-=32;
        if (cscr!=cdest && cscr!='?' && cscr!='*')
                {
                err=false;
                break;
                }
        dest++;
        scr++;
        }

return err;
}
//------------------------------------------------------------------------------
bool TCSVBase::FindInString(char* scr, char* dest)
{
bool bStatus;
if (!(bStatus=CompareEnchanced(scr, dest)))
        while (*dest++)
                {
                if (*(dest-1)==' ' || *(dest-1)=='\"')
                        {
                        if (bStatus=CompareEnchanced(scr, dest)) return bStatus;
                        }
                }
return bStatus;
}
//------------------------------------------------------------------------------
void TCSVBase::FindForTreeInit()
{
bool bFlag=false;
iAbonentsMap=0;
iAbonentsMapOAO=0;
for (int i=0; i<iAbonents; i++)
        {
        if (*lpArray[i][0]=='@')
                {
                lpArray[i][0]+=1;
                bFlag=true;
                }
        if (bFlag)      iAbonentsMapOAO++;
        else
                {
                iAbonentsMap++;
                }
        }
}
//------------------------------------------------------------------------------
typedef struct
{
int ARow; // 
char* S; //   
} TMyDataArray;

//------------------------------------------------------------------------------
static int __fastcall CompareDownArray (void * Item1, void * Item2)
{
return lstrcmp(((TMyDataArray*)Item2)->S, ((TMyDataArray*)Item1)->S);
}
//------------------------------------------------------------------------------
static int __fastcall CompareUpArray (void * Item1, void * Item2)
{
return lstrcmp(((TMyDataArray*)Item1)->S, ((TMyDataArray*)Item2)->S);
}
//------------------------------------------------------------------------------
void TCSVBase::SortArrayBuf(int iRows, int iCol)
{
int ACol=iCol;
int i,j,ARow;
if (!iDirectSort) return;

char*** lpArrayBufSort;
lpArrayBufSort=new char**[iAbonents+1];
for (int l=0; l<iRows; l++)     lpArrayBufSort[l]=new char*[iColumn];

TList *SortList=new TList;
TList *TempList=new TList;
SortList->Count=iRows;
TempList->Count=iRows;
for (ARow=0; ARow < iRows; ARow++)
        {
        TMyDataArray *md=new TMyDataArray;
        md->ARow=ARow;
        md->S=lpArrayBuf[ARow][ACol];
        SortList->Items[ARow]=md;
        TempList->Items[ARow]=((void *)ARow);
        }

iDirectSort[ACol]*=-1;
if (iDirectSort[ACol]==1) SortList->Sort(CompareUpArray);
else SortList->Sort(CompareDownArray);
for (i=0; i < SortList->Count; i++)
        {
        TMyDataArray *md=(TMyDataArray *)(SortList->Items[i]);
        ARow=md->ARow;
        for (int l=0; l<iColumn; l++)
                {
                lpArrayBufSort[i][l]= lpArrayBuf[ARow][l];
                }
        }
for (i=0; i < SortList->Count; i++)
        {
        for (int l=0; l<iColumn; l++)
                {
                lpArrayBuf[i][l]=lpArrayBufSort[i][l];
                }
        }

delete TempList;
for(i=0; i < SortList->Count; i++)
        {
        delete (TMyDataArray *)(SortList->Items[i]);
        }
delete SortList;

for (int l=0; l<iRows; l++)
        {
        delete[] lpArrayBufSort[l];
        }
delete[] lpArrayBufSort;
}
//------------------------------------------------------------------------------