#include <vcl.h>
#pragma hdrstop

#include "Defines.h"
#include "Unit13.h"
#include "Main.h"
#include "CSV.cpp"
#include "Unit5.h"
#include "Unit17.h"

#pragma package(smart_init)
#pragma resource "*.dfm"
TFormCityCodes *FormCityCodes;
TCSVBase CityCodes=TCSVBase(FILENAME_CITY_CODES, 3);
//------------------------------------------------------------------------------
__fastcall TFormCityCodes::TFormCityCodes(TComponent* Owner)
        : TForm(Owner)
{
y=yold=-1;
if (CityCodes.bError)
        {
        MainForm->bCityCodes=false;
        MainForm->ToolButtonCityCodes->Visible=false;
        MainForm->NCityCodes->Visible=false;
        Close();
        return;
        }
        
MainForm->bCityCodes=true;
MainForm->bFormCityCodes=true;
StringGrid1->DoubleBuffered=true;

if (MainForm->Prefs.bSaveText)  ComboBox1->Text=MainForm->Prefs.szCity;
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::FormActivate(TObject *Sender)
{
MainForm->ToolButtonCityCodes->Down=true;
MainForm->SeeTitle(FORM_CODES);
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::FormClose(TObject *Sender, TCloseAction &Action)
{
MainForm->bFormCityCodes=false;
MainForm->ToolButtonCityCodes->Down=false;
Action=caFree;
}
//------------------------------------------------------------------------------

void __fastcall TFormCityCodes::NCopyClick(TObject *Sender)
{
MainForm->CopyAt((void*) StringGrid1, true, (void*) &CityCodes);
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::ComboBox1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
if (Key==VK_RETURN && ButtonSearch->Enabled)    ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::ComboBox1Change(TObject *Sender)
{
ButtonSearch->Enabled=true;
if (MainForm->Prefs.bAutoSearch) ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::NOldNamesClick(TObject *Sender)
{
FormOldNames->ShowModal();
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::NAddInBookClick(TObject *Sender)
{
MainForm->CopyAt((void*) StringGrid1, false,(void*) &CityCodes);
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::ButtonAdditionClick(TObject *Sender)
{
TPoint p=TPoint(0, ButtonAddition->Height);
p=ButtonAddition->ClientToScreen(p);
PopupMenu2->Popup(p.x, p.y);
}
//-----------------------------------------------------------------------------
void __fastcall TFormCityCodes::HeaderControl1SectionResize(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//-----------------------------------------------------------------------------
void __fastcall TFormCityCodes::FormResize(TObject *Sender)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------

void __fastcall TFormCityCodes::StringGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
TStringGrid *SG=(TStringGrid *)Sender;
TCanvas *Cv=SG->Canvas;
Cv->FillRect(Rect);
if (ARow==y && ACol && !MainForm->Prefs.bSelectionText)
        {
        Cv->Font->Style = TFontStyles()<< fsBold;
        }
if (ACol==0)
        {
        AnsiString Ansi=ARow+1;
        DrawText(Cv->Handle,Ansi.c_str(),Ansi.Length(),
               &Rect,DT_VCENTER|DT_SINGLELINE );
        }
int iTextFlag=DT_VCENTER|DT_SINGLELINE;
if (ACol==3)
        {
        iTextFlag=DT_VCENTER|DT_CENTER|DT_SINGLELINE;
        }
if (ACol)
        {
        DrawText(Cv->Handle, CityCodes.lpArrayBuf[ARow][ACol-1],strlen(CityCodes.lpArrayBuf[ARow][ACol-1]),
            &Rect,iTextFlag);
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::StringGrid1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (!MainForm->Prefs.bSelectionText)
        {
        TStringGrid* StringGrid=(TStringGrid*) Sender;
        y=(StringGrid->MouseCoord(X,Y)).Y;
        if (y!=yold)    StringGrid->Repaint();
        yold=y;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::PopupMenu1Popup(TObject *Sender)
{
if (!StringGrid1->Visible)
        {
        NCopy->Enabled=false;
        NAddInBook->Enabled=false;
        }
else
        {
        NCopy->Enabled=true;
        NAddInBook->Enabled=true;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::ButtonSearchClick(TObject *Sender)
{
DWORD dT1=GetTickCount();
DWORD dT3=0, dT4=0;
ButtonSearch->Enabled=false;
char cTextFromCombo[MAX_LEN_STRING];
ComboBox1->GetTextBuf(cTextFromCombo, MAX_LEN_STRING);
CityCodes.lpArrayScr[0]=cTextFromCombo;
StringGrid1->RowCount=CityCodes.iAbonents;
int i=CityCodes.FindAll(SEARCH_CITY_CODES);
if (i)
        {
        StringGrid1->RowCount=i;
        AnsiString aAnsi=": ";
        aAnsi+=i;
        aAnsi+="  ";
        aAnsi+=CityCodes.iAbonents;
        aAnsi+="    ";
        DWORD dT2=GetTickCount();
        aAnsi+=double(dT2-dT1-(dT4-dT3))/1000;
        aAnsi+=" .";
        StringGrid1->Hint=aAnsi;
        StringGrid1->Visible=true;
        MainForm->bNoMessageHelp=false;

        }
else
        {
        StringGrid1->Visible=false;
        MainForm->MessageHelp(SPRAVKA_CODES);
        MainForm->bNoMessageHelp=false;

        }
StringGrid1->Repaint();
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::NKostromaCodesClick(TObject *Sender)
{
FormKostromaCodes->ShowModal();
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::ButtonNewSearchClick(TObject *Sender)
{
ButtonSearch->Enabled=true;
ComboBox1->Text="";
StringGrid1->Visible=false;
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::HeaderControl1SectionClick(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
int n;
for (n=0; HeaderControl->Sections->Count;n++)
        {
        if (HeaderControl->Sections->Items[n]==Section) break;
        }
if (!StringGrid1->Visible || !n) return;

CityCodes.SortArrayBuf(StringGrid1->RowCount, n-1);
StringGrid1->Refresh();
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::FormPaint(TObject *Sender)
{
static bool b=true;
if (b && MainForm->Prefs.bSeeAllSaves)
        {
        b=false;
        MainForm->bNoMessageHelp=true;
        ButtonSearch->Click();
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::FormDestroy(TObject *Sender)
{
lstrcpy(MainForm->Prefs.szCity, ComboBox1->Text.c_str());
}
//------------------------------------------------------------------------------
int TFormCityCodes::SearchNumberSaves(char* cCode)
{
CityCodes.lpArrayScr[0]=cCode;
CityCodes.lpArrayScr[1]=cCode;
CityCodes.lpArrayScr[2]=cCode;
CityCodes.lpArrayScr[3]=cCode;
CityCodes.lpArrayScr[4]=cCode;

int i=0;
if (!CityCodes.bError)
        {
        while (CityCodes.Find(SEARCH_CITY_CODES))
                {
                i++;
                }
        }
return i;
}
//------------------------------------------------------------------------------
void __fastcall TFormCityCodes::Button1Click(TObject *Sender)
{
FormKostromaCodes->ShowModal();        
}
//---------------------------------------------------------------------------

void __fastcall TFormCityCodes::Button2Click(TObject *Sender)
{
FormOldNames->ShowModal();        
}
//---------------------------------------------------------------------------

