#include <vcl.h>
#pragma hdrstop

#include "Defines.h"
#include "Unit14.h"
#include "CSV.cpp"
#include "Main.h"

#pragma package(smart_init)
#pragma resource "*.dfm"

TFormCountryCodes *FormCountryCodes;
TCSVBase CountryCodes=TCSVBase(FILENAME_COUNTRY_CODES, 4);
//------------------------------------------------------------------------------
__fastcall TFormCountryCodes::TFormCountryCodes(TComponent* Owner)
        : TForm(Owner)
{
y=yold=-1;
if (CountryCodes.bError)
        {
        MainForm->bCountryCodes=false;
        MainForm->ToolButtonCountryCodes->Visible=false;
        MainForm->NCountryCodes->Visible=false;
        Close();
        return;
        }
MainForm->bCountryCodes=true;

if (CountryCodes.iMaxNumSeparator<4)
        {
        HeaderControl1->Sections->Delete(3);
        StringGrid1->ColCount=4;
        }

MainForm->bFormCountryCodes=true;
StringGrid1->DoubleBuffered=true;

if (MainForm->Prefs.bSaveText)  ComboBox1->Text=MainForm->Prefs.szCountry;
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::FormActivate(TObject *Sender)
{
MainForm->ToolButtonCountryCodes->Down=true;
MainForm->SeeTitle(FORM_ICODES);
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::FormClose(TObject *Sender, TCloseAction &Action)
{
MainForm->bFormCountryCodes=false;
MainForm->ToolButtonCountryCodes->Down=false;
Action=caFree;
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::NCopyClick(TObject *Sender)
{
MainForm->CopyAt((void*) StringGrid1, true, NULL);
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::ComboBox1Change(TObject *Sender)
{
ButtonSearch->Enabled=true;
if (MainForm->Prefs.bAutoSearch) ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::ComboBox1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
if (Key==VK_RETURN && ButtonSearch->Enabled)    ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::NAddInBookClick(TObject *Sender)
{
MainForm->CopyAt((void* ) StringGrid1, false, NULL);
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::HeaderControl1SectionResize(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::FormResize(TObject *Sender)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::StringGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
TStringGrid *SG=(TStringGrid *)Sender;
TCanvas *Cv=SG->Canvas;
Cv->FillRect(Rect);
if (ARow==y && ACol && !MainForm->Prefs.bSelectionText)
        {
        Cv->Font->Style = TFontStyles()<< fsBold;
        }
if (!ACol)
        {
        AnsiString Ansi=ARow+1;
        DrawText(Cv->Handle,Ansi.c_str(),Ansi.Length(),
              &Rect,DT_VCENTER|DT_SINGLELINE );
        }
int iTextFlag=DT_VCENTER|DT_SINGLELINE;
if (ACol==2 || ACol==3 || ACol==4)
        {
        iTextFlag=DT_VCENTER|DT_CENTER|DT_SINGLELINE;
        }
if (ACol)
        {
        DrawText(Cv->Handle,SG->Cells[ACol][ARow].c_str(),SG->Cells[ACol][ARow].Length(),
            &Rect,iTextFlag);
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::StringGrid1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (!MainForm->Prefs.bSelectionText)
        {
        TStringGrid* StringGrid=(TStringGrid*) Sender;
        y=(StringGrid->MouseCoord(X,Y)).Y;
        if (y!=yold)    StringGrid->Repaint();
        yold=y;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::PopupMenu1Popup(TObject *Sender)
{
if (!StringGrid1->Visible)
        {
        NCopy->Enabled=false;
        NAddInBook->Enabled=false;
        }
else
        {
        NCopy->Enabled=true;
        NAddInBook->Enabled=true;
        }
}
//------------------------------------------------------------------------------

void __fastcall TFormCountryCodes::ButtonSearchClick(TObject *Sender)
{
DWORD dT1=GetTickCount();
DWORD dT3=0, dT4=0;
static bool bStart=true;
if (bStart)
        {
        MainForm->NumToStringGrid((void*)StringGrid1, CountryCodes.iAbonents);
        bStart=false;
        }
static char cTextFromCombo[MAX_LEN_STRING];
ComboBox1->GetTextBuf(cTextFromCombo, MAX_LEN_STRING);
AnsiString Ansi=ComboBox1->Text.c_str();
Ansi=Ansi.UpperCase();
CountryCodes.lpArrayScr[0]=cTextFromCombo;
CountryCodes.lpArrayScr[1]=Ansi.c_str();
CountryCodes.lpArrayScr[2]=Ansi.c_str();
CountryCodes.lpArrayScr[3]=cTextFromCombo;

int i=0;
int iFlag=SEARCH_COUNTRY_CODES;
if (CountryCodes.iMaxNumSeparator>3) iFlag=SEARCH_COUNTRY_CODES2;
while (CountryCodes.Find(iFlag))
        {
        StringGrid1->Cells[1][i]=CountryCodes.lpArrayDest[0];
        StringGrid1->Cells[2][i]=CountryCodes.lpArrayDest[1];
        StringGrid1->Cells[3][i]=CountryCodes.lpArrayDest[2];
        if (CountryCodes.iMaxNumSeparator>3)    StringGrid1->Cells[4][i]=CountryCodes.lpArrayDest[3];
        i++;
        }
if (i)
        {
        AnsiString aAnsi=": ";
        aAnsi+=i;
        aAnsi+="  ";
        aAnsi+=CountryCodes.iAbonents;
        aAnsi+="    ";
        DWORD dT2=GetTickCount();
        aAnsi+=double(dT2-dT1-(dT4-dT3))/1000;
        aAnsi+=" .";
        StringGrid1->Hint=aAnsi;
        StringGrid1->RowCount=i;
        StringGrid1->Visible=true;
        MainForm->bNoMessageHelp=false;
        }
else
        {
        StringGrid1->Visible=false;
        StringGrid1->Hint=" .";
        MainForm->MessageHelp(SPRAVKA_CODES);
        MainForm->bNoMessageHelp=false;
        }
ButtonSearch->Enabled=false;
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::ButtonNewSearchClick(TObject *Sender)
{
ButtonSearch->Enabled=true;
ComboBox1->Text="";
StringGrid1->Visible=false;
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::HeaderControl1SectionClick(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
int i;
for (i=0; HeaderControl->Sections->Count;i++)
        {
        if (HeaderControl->Sections->Items[i]==Section) break;
        }
CountryCodes.iDirectSort[i]*=-1;
MainForm->SortStringGrid((void*) StringGrid1, i, CountryCodes.iDirectSort[i]);
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::FormPaint(TObject *Sender)
{
static bool b=true;
if (b && MainForm->Prefs.bSeeAllSaves)
        {
        b=false;
        MainForm->bNoMessageHelp=true;        
        ButtonSearch->Click();
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormCountryCodes::FormDestroy(TObject *Sender)
{
lstrcpy(MainForm->Prefs.szCountry, ComboBox1->Text.c_str());
}
//------------------------------------------------------------------------------
int TFormCountryCodes::SearchNumberSaves(char* cCode)
{
CountryCodes.lpArrayScr[0]=cCode;
CountryCodes.lpArrayScr[1]=cCode;
CountryCodes.lpArrayScr[2]=cCode;
CountryCodes.lpArrayScr[3]=cCode;
CountryCodes.lpArrayScr[4]=cCode;

int i=0;
if (!CountryCodes.bError)
        {
        while (CountryCodes.Find(SEARCH_COUNTRY_CODES))
                {
                i++;
                }
        }
return i;
}
//------------------------------------------------------------------------------
