#include <vcl.h>
#pragma hdrstop

#include "Unit17.h"
#include "Unit13.h"
#include "Main.h"
#include "CSV.cpp"

#pragma package(smart_init)
#pragma resource "*.dfm"

TFormKostromaCodes *FormKostromaCodes;
TCSVBase KostromaCodes=TCSVBase(FILENAME_KOSTROMA_CODES, 3);
int y=-1;
int yold=-1;
//------------------------------------------------------------------------------
__fastcall TFormKostromaCodes::TFormKostromaCodes(TComponent* Owner)
        : TForm(Owner)
{
if (KostromaCodes.bError)
        {
        if (MainForm->bFormCityCodes)   FormCityCodes->NKostromaCodes->Enabled=false;
        return;
        }
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
StringGrid1->RowCount=KostromaCodes.iAbonents;
int i=0;
while (KostromaCodes.Find(SEARCH_KOSTROMA_CODES))
        {
        StringGrid1->Cells[1][i]=KostromaCodes.lpArrayDest[0];
        StringGrid1->Cells[2][i]=KostromaCodes.lpArrayDest[1];
        StringGrid1->Cells[3][i++]=KostromaCodes.lpArrayDest[2];
        }
MainForm->NumToStringGrid((void*)StringGrid1, KostromaCodes.iAbonents);
StringGrid1->DoubleBuffered=true;
}
//------------------------------------------------------------------------------
void __fastcall TFormKostromaCodes::NCopyClick(TObject *Sender)
{
MainForm->CopyAt((void*) StringGrid1, true, NULL);
}
//------------------------------------------------------------------------------
void __fastcall TFormKostromaCodes::NAddInBookClick(TObject *Sender)
{
MainForm->CopyAt((void*) StringGrid1, false, NULL);
}
//------------------------------------------------------------------------------
void __fastcall TFormKostromaCodes::HeaderControl1SectionResize(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormKostromaCodes::FormResize(TObject *Sender)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormKostromaCodes::FormShow(TObject *Sender)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormKostromaCodes::StringGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
TStringGrid *SG=(TStringGrid *)Sender;
TCanvas *Cv=SG->Canvas;
Cv->FillRect(Rect);
if (ARow==y && ACol && !MainForm->Prefs.bSelectionText)
        {
        Cv->Font->Style = TFontStyles()<< fsBold;
        }
if (!ACol)
        {
        AnsiString Ansi=ARow+1;
        DrawText(Cv->Handle,Ansi.c_str(),Ansi.Length(),
              &Rect,DT_VCENTER|DT_SINGLELINE );
        }
int iTextFlag=DT_VCENTER|DT_SINGLELINE;
if (ACol==2 || ACol==3)
        {
        iTextFlag=DT_VCENTER|DT_CENTER|DT_SINGLELINE;
        }
if (ACol)
        {
        DrawText(Cv->Handle,SG->Cells[ACol][ARow].c_str(),SG->Cells[ACol][ARow].Length(),
             &Rect,iTextFlag);
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormKostromaCodes::StringGrid1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (!MainForm->Prefs.bSelectionText)
        {
        TStringGrid* StringGrid=(TStringGrid*) Sender;
        y=(StringGrid->MouseCoord(X,Y)).Y;
        if (y!=yold)
                {
                StringGrid->Repaint();
                }
        yold=y;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormKostromaCodes::StringGrid1KeyPress(TObject *Sender,
      char &Key)
{
if (Key==VK_ESCAPE) Close();
}
//------------------------------------------------------------------------------
void __fastcall TFormKostromaCodes::HeaderControl1SectionClick(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
int i;
for (i=0; HeaderControl->Sections->Count;i++)
        {
        if (HeaderControl->Sections->Items[i]==Section) break;
        }
if (!i) return;
KostromaCodes.iDirectSort[i-1]*=-1;
MainForm->SortStringGrid((void*) StringGrid1, i, KostromaCodes.iDirectSort[i-1]);
//MainForm->ImageInHeaderControl(HeaderControl, Section, KostromaCodes.iDirectSort, false);
HeaderControl->Update();
}
//------------------------------------------------------------------------------

