#include <vcl.h>
#pragma hdrstop

#include "Defines.h"
#include "CSV.cpp"
#include "Main.h"
#include "Unit20.h"

#pragma package(smart_init)
#pragma resource "*.dfm"

TFormPost *FormPost;
TCSVBase PostIndexes=TCSVBase(FILENAME_POST_INDEXES, 4);

//------------------------------------------------------------------------------
__fastcall TFormPost::TFormPost(TComponent* Owner)
        : TForm(Owner)
{
y=-1;
yold=-1;

MainForm->bFormPost=true;
if (PostIndexes.bError)
        {
        MainForm->bPost=false;
        MainForm->ToolButtonPost->Visible=false;
        MainForm->NPost->Visible=false;
        Close();
        return;
        }

MainForm->bPost=true;
StringGrid1->DoubleBuffered=true;
if (MainForm->Prefs.bSaveText)
        {
        ComboBox1->Text=MainForm->Prefs.szPost;
        }
if (MainForm->Prefs.bSaveText)  ComboBox1->Text=MainForm->Prefs.szPost;

}
//------------------------------------------------------------------------------
void __fastcall TFormPost::FormActivate(TObject *Sender)
{
MainForm->ToolButtonPost->Down=true;
MainForm->SeeTitle(FORM_POST);
}
//------------------------------------------------------------------------------
void __fastcall TFormPost::FormClose(TObject *Sender, TCloseAction &Action)
{
MainForm->bFormPost=false;
MainForm->ToolButtonPost->Down=false;
Action=caFree;
}
//------------------------------------------------------------------------------
void __fastcall TFormPost::StringGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
TStringGrid *StringGrid=(TStringGrid *)Sender;
TCanvas *Cv=StringGrid->Canvas;
Cv->FillRect(Rect);
if (ARow==y && ACol && !MainForm->Prefs.bSelectionText)
        {
        Cv->Font->Style = TFontStyles()<< fsBold;
        }
if (!ACol)
        {
        AnsiString Ansi=ARow+1;
        DrawText(Cv->Handle,Ansi.c_str(),Ansi.Length(),
               &Rect,DT_VCENTER|DT_SINGLELINE );
        }
int iTextFlag=DT_VCENTER|DT_SINGLELINE;
if (ACol==1)
        {
        iTextFlag=DT_VCENTER|DT_CENTER|DT_SINGLELINE;
        }
if (ACol)
        {
        DrawText(Cv->Handle,PostIndexes.lpArrayBuf[ARow][ACol-1],strlen(PostIndexes.lpArrayBuf[ARow][ACol-1]),
            &Rect,iTextFlag);
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormPost::ButtonNewSearchClick(TObject *Sender)
{
ButtonSearch->Enabled=true;
ComboBox1->Text="";
StringGrid1->Visible=false;
}
//------------------------------------------------------------------------------
void __fastcall TFormPost::NCopyClick(TObject *Sender)
{
MainForm->CopyAt((void*) StringGrid1, true, (void*) &PostIndexes);
}
//------------------------------------------------------------------------------
void __fastcall TFormPost::NAddInBookClick(TObject *Sender)
{
MainForm->CopyAt((void* ) StringGrid1, false, (void*) &PostIndexes);
}
//------------------------------------------------------------------------------
void __fastcall TFormPost::ComboBox1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
if (Key==VK_RETURN && ButtonSearch->Enabled)    ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormPost::ComboBox1Change(TObject *Sender)
{
if (MainForm->Prefs.bAutoSearch) ButtonSearch->Click();
else    ButtonSearch->Enabled=true;
}
//------------------------------------------------------------------------------
void __fastcall TFormPost::FormResize(TObject *Sender)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormPost::ButtonSearchClick(TObject *Sender)
{
DWORD dT1=GetTickCount();
DWORD dT3=0, dT4=0;
static char cTextFromCombo[MAX_LEN_STRING];
ComboBox1->GetTextBuf(cTextFromCombo, MAX_LEN_STRING);

PostIndexes.lpArrayScr[0]=cTextFromCombo;
PostIndexes.lpArrayScr[1]=cTextFromCombo;
PostIndexes.lpArrayScr[2]="";
PostIndexes.lpArrayScr[3]="";
PostIndexes.lpArrayScr[4]="";

PostIndexes.UpperCase(cTextFromCombo);
int i=PostIndexes.FindAll(SEARCH_POST_INDEXES);
if (i)
        {
        AnsiString anAnsi=": ";
        anAnsi+=i;
        anAnsi+="  ";
        anAnsi+=PostIndexes.iAbonents;
        anAnsi+="    ";
        DWORD dT2=GetTickCount();
        anAnsi+=double(dT2-dT1-(dT4-dT3))/1000;
        anAnsi+=" .";
        StringGrid1->Hint=anAnsi;
        StringGrid1->RowCount=i;
        StringGrid1->Visible=true;
        MainForm->bNoMessageHelp=false;
        }
else
        {
        StringGrid1->Visible=false;
        StringGrid1->Hint=" .";
        MainForm->MessageHelp(SPRAVKA_DEFAULT);
        MainForm->bNoMessageHelp=false;
        }
ButtonSearch->Enabled=false;
StringGrid1->Repaint();
}
//------------------------------------------------------------------------------
void __fastcall TFormPost::HeaderControl1SectionResize(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);

}
//------------------------------------------------------------------------------
void __fastcall TFormPost::StringGrid1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (!MainForm->Prefs.bSelectionText)
        {
        y=(StringGrid1->MouseCoord(X,Y)).Y;
        if (y!=yold)    StringGrid1->Repaint();
        yold=y;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormPost::PopupMenu1Popup(TObject *Sender)
{
if (!StringGrid1->Visible)
        {
        NCopy->Enabled=false;
        NAddInBook->Enabled=false;
        }
else
        {
        NCopy->Enabled=true;
        NAddInBook->Enabled=true;
        }
}
//------------------------------------------------------------------------------

void __fastcall TFormPost::HeaderControl1SectionClick(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
int n;
for (n=0; HeaderControl->Sections->Count;n++)
        {
        if (HeaderControl->Sections->Items[n]==Section) break;
        }
if (!StringGrid1->Visible || !n) return;

PostIndexes.SortArrayBuf(StringGrid1->RowCount, n-1);
StringGrid1->Refresh();
}
//------------------------------------------------------------------------------
void __fastcall TFormPost::FormPaint(TObject *Sender)
{
static bool b=true;
if (b && MainForm->Prefs.bSeeAllSaves)
        {
        b=false;
        MainForm->bNoMessageHelp=true;
        ButtonSearch->Click();
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormPost::FormDestroy(TObject *Sender)
{
lstrcpy(MainForm->Prefs.szPost, ComboBox1->Text.c_str());
}
//------------------------------------------------------------------------------
int TFormPost::SearchNumberSaves(char* cCode)
{
PostIndexes.lpArrayScr[0]=cCode;
PostIndexes.lpArrayScr[1]=cCode;
PostIndexes.lpArrayScr[2]=cCode;
PostIndexes.lpArrayScr[3]=cCode;
PostIndexes.lpArrayScr[4]=cCode;

int i=0;
if (!PostIndexes.bError)
        {
        while (PostIndexes.Find(SEARCH_POST_INDEXES))
                {
                i++;
                }
        }
return i;
}
//------------------------------------------------------------------------------
