#include <vcl.h>
#pragma hdrstop

#include "Unit3.h"
#include "Main.h"
#include "Defines.h"

#define STEP 60
#define ALFA_STEP       20
#define MAX_ALPHA 235
#define WIDTH_IMAGE 75

#pragma resource "*.dfm"
TFormAbout *FormAbout;

static int iVisibleStep=0;

//------------------------------------------------------------------------------
__fastcall TFormAbout::TFormAbout(TComponent* AOwner)
	: TForm(AOwner)
{
char cBuf[MAX_LEN_STRING];
lstrcpy(cBuf, MainForm->cVersion);
lstrcat(cBuf, " ");
lstrcat(cBuf, MainForm->cDate);

LabelVersion->Caption=cBuf;
LabelProg1->Caption=MainForm->cTitle1;
LabelProg2->Caption=MainForm->cTitle2;
LabelVersion->Left=LabelProg2->Left+(LabelProg2->Width-LabelVersion->Width)/2;
LabelInet->Caption=MainForm->cShortInet;
LabelMail->Caption=MainForm->cShortMail;

try
        {
        Image1->Picture->LoadFromFile(FILENAME_PICTURE_ABOUT);
        }
catch (...)
        {
        LabelProg1->Left-=STEP;
        LabelProg2->Left-=STEP;
        LabelVersion->Left-=STEP;
        LabelMail->Left-=STEP;
        LabelInet->Left-=STEP;
        LabelCompany->Left-=STEP;
        LabelAuthor->Left-=STEP;
        Panel2->Visible=false;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormAbout::ButtonOkClick(TObject *Sender)
{
Close();
}
//------------------------------------------------------------------------------
void __fastcall TFormAbout::ButtonOkKeyPress(TObject *Sender, char &Key)
{
if (Key==VK_ESCAPE) Close();
}
//------------------------------------------------------------------------------
void __fastcall TFormAbout::LabelMailClick(TObject *Sender)
{
ShellExecute( FormAbout->Handle, "open", MainForm->cMail, NULL, NULL, SW_SHOWNORMAL);
}
//------------------------------------------------------------------------------

void __fastcall TFormAbout::LabelInetClick(TObject *Sender)
{
ShellExecute( FormAbout->Handle, "open", MainForm->cInet, NULL, NULL, SW_SHOWNORMAL);
}
//------------------------------------------------------------------------------
void __fastcall TFormAbout::FormShow(TObject *Sender)
{
iVisibleStep=0;

LabelProg1->Visible=false;
LabelProg2->Visible=false;
LabelVersion->Visible=false;
LabelAuthor->Visible=false;
LabelCompany->Visible=false;
LabelMail->Visible=false;
LabelInet->Visible=false;

Timer1->Enabled=true;
Timer2->Enabled=true;

}
//------------------------------------------------------------------------------
void __fastcall TFormAbout::FormClose(TObject *Sender,
      TCloseAction &Action)
{
AlphaBlendValue=0;
iVisibleStep=0;

LabelProg1->Visible=false;
LabelProg2->Visible=false;
LabelVersion->Visible=false;
LabelAuthor->Visible=false;
LabelCompany->Visible=false;
LabelMail->Visible=false;
LabelInet->Visible=false;

Timer1->Enabled=false;
Timer2->Enabled=false;
}
//------------------------------------------------------------------------------

void __fastcall TFormAbout::Timer1Timer(TObject *Sender)
{
if (AlphaBlendValue<MAX_ALPHA)        AlphaBlendValue+=ALFA_STEP;
else    Timer1->Enabled=false;
}
//------------------------------------------------------------------------------


void __fastcall TFormAbout::LabelMailMouseEnter(TObject *Sender)
{
LabelMail->Font->Color=clRed;
LabelMail->Font->Style = TFontStyles();
}
//---------------------------------------------------------------------------

void __fastcall TFormAbout::LabelInetMouseEnter(TObject *Sender)
{
LabelInet->Font->Color=clRed;
LabelInet->Font->Style = TFontStyles();
}
//---------------------------------------------------------------------------

void __fastcall TFormAbout::LabelInetMouseLeave(TObject *Sender)
{
LabelInet->Font->Color=clHighlight;
LabelInet->Font->Style = TFontStyles()<< fsUnderline;

}
//---------------------------------------------------------------------------

void __fastcall TFormAbout::LabelMailMouseLeave(TObject *Sender)
{
LabelMail->Font->Color=clHighlight;
LabelMail->Font->Style = TFontStyles()<< fsUnderline;
}
//---------------------------------------------------------------------------

void __fastcall TFormAbout::Timer2Timer(TObject *Sender)
{
switch (iVisibleStep)
        {
        case    1:
                LabelProg1->Font->Color=clRed;
                LabelProg1->Visible=true;
                break;
        case    2:
                LabelProg1->Font->Color=clWindowText;
                LabelProg2->Font->Color=clRed;
                LabelProg2->Visible=true;
                break;
        case    3:
                LabelProg2->Font->Color=clWindowText;
                LabelVersion->Font->Color=clRed;
                LabelVersion->Visible=true;
                break;
        case    4:
                LabelVersion->Font->Color=clWindowText;
                LabelAuthor->Font->Color=clRed;
                LabelAuthor->Visible=true;
                break;
        case    5:
                LabelAuthor->Font->Color=clWindowText;
                LabelCompany->Font->Color=clRed;
                LabelCompany->Visible=true;
                break;
        case    6:
                LabelCompany->Font->Color=clWindowText;
                LabelMail->Font->Color=clRed;
                LabelMail->Visible=true;
                break;
        case    7:
                LabelMail->Font->Color=clHighlight;
                LabelInet->Font->Color=clRed;
                LabelInet->Visible=true;
                break;
        case    8:
                LabelInet->Font->Color=clHighlight;
                Timer2->Enabled=false;
                break;
        }
iVisibleStep++;
}
//---------------------------------------------------------------------------

