#include <vcl.h>
#pragma hdrstop

#include "Defines.h"
#include "Main.h"
#include "CSV.cpp"
#include "Unit81.h"

#pragma package(smart_init)
#pragma resource "*.dfm"

TFormMobileCodes *FormMobileCodes;
TCSVBase MobileCodes=TCSVBase(FILENAME_MOBILE_CODES, 3);

//------------------------------------------------------------------------------
__fastcall TFormMobileCodes::TFormMobileCodes(TComponent* Owner)
        : TForm(Owner)
{
y=yold=-1;

if (MobileCodes.bError)
        {
        MainForm->bMobileCodes=false;
        MainForm->ToolButtonMobileCodes->Visible=false;
        MainForm->NMobileCodes->Visible=false;
        Close();
        return;
        }

MainForm->bMobileCodes=true;
MainForm->bFormMobileCodes=true;
StringGrid1->DoubleBuffered=true;

if (MainForm->Prefs.bSaveText)  ComboBox1->Text=MainForm->Prefs.szMobile;
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::ButtonSearchClick(TObject *Sender)
{
DWORD dT1=GetTickCount();
DWORD dT3=0, dT4=0;
ButtonSearch->Enabled=false;
char cTextFromCombo[MAX_LEN_STRING];
ComboBox1->GetTextBuf(cTextFromCombo, MAX_LEN_STRING);
MobileCodes.lpArrayScr[0]=cTextFromCombo;
//MobileCodes.iCurrentAbonent=0;
StringGrid1->RowCount=MobileCodes.iAbonents;
int i=MobileCodes.FindAll(SEARCH_MOBILE_CODES);
if (i)
        {
        StringGrid1->RowCount=i;
        AnsiString aAnsi=": ";
        aAnsi+=i;
        aAnsi+="  ";
        aAnsi+=MobileCodes.iAbonents;
        aAnsi+="    ";
        DWORD dT2=GetTickCount();
        aAnsi+=double(dT2-dT1-(dT4-dT3))/1000;
        aAnsi+=" .";
        StringGrid1->Hint=aAnsi;
        StringGrid1->Visible=true;
        MainForm->bNoMessageHelp=false;
        }
else
        {
        StringGrid1->Visible=false;
        MainForm->MessageHelp(SPRAVKA_CODES);
        MainForm->bNoMessageHelp=false;
        }
StringGrid1->Repaint();
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::ButtonNewSearchClick(TObject *Sender)
{
ButtonSearch->Enabled=true;
ComboBox1->Text="";
StringGrid1->Visible=false;
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::FormActivate(TObject *Sender)
{
MainForm->ToolButtonMobileCodes->Down=true;
MainForm->SeeTitle(FORM_MOBILE);
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::FormClose(TObject *Sender,
      TCloseAction &Action)
{
MainForm->bFormMobileCodes=false;
MainForm->ToolButtonMobileCodes->Down=false;
Action=caFree;
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::NCopyClick(TObject *Sender)
{
MainForm->CopyAt((void*) StringGrid1, true, (void*) &MobileCodes);
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::ComboBox1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
if (Key==VK_RETURN && ButtonSearch->Enabled)    ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::ComboBox1Change(TObject *Sender)
{
ButtonSearch->Enabled=true;
if (MainForm->Prefs.bAutoSearch) ButtonSearch->Click();
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::NAddInBookClick(TObject *Sender)
{
MainForm->CopyAt((void*) StringGrid1, false,(void*) &MobileCodes);
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::HeaderControl1SectionResize(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::FormResize(TObject *Sender)
{
MainForm->ResizeStringGrid((void*) StringGrid1, (void*) HeaderControl1);
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::StringGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
TStringGrid *SG=(TStringGrid *)Sender;
TCanvas *Cv=SG->Canvas;
Cv->FillRect(Rect);
if (ARow==y && ACol && !MainForm->Prefs.bSelectionText)
        {
        Cv->Font->Style = TFontStyles()<< fsBold;
        }
if (ACol==0)
        {
        AnsiString Ansi=ARow+1;
        DrawText(Cv->Handle,Ansi.c_str(),Ansi.Length(),
              &Rect,DT_VCENTER|DT_SINGLELINE );
        }
int iTextFlag=DT_VCENTER|DT_SINGLELINE;
if (ACol==3)
        {
        iTextFlag=DT_VCENTER|DT_CENTER|DT_SINGLELINE;
        }
if (ACol)
        {
        DrawText(Cv->Handle, MobileCodes.lpArrayBuf[ARow][ACol-1],
                        strlen(MobileCodes.lpArrayBuf[ARow][ACol-1]), &Rect,iTextFlag);
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::StringGrid1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (!MainForm->Prefs.bSelectionText)
        {
        TStringGrid* StringGrid=(TStringGrid*) Sender;
        y=(StringGrid->MouseCoord(X,Y)).Y;
        if (y!=yold)    StringGrid->Repaint();
        yold=y;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::PopupMenu1Popup(TObject *Sender)
{
if (!StringGrid1->Visible)
        {
        NCopy->Enabled=false;
        NAddInBook->Enabled=false;
        }
else
        {
        NCopy->Enabled=true;
        NAddInBook->Enabled=true;
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::HeaderControl1SectionClick(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
int n;
for (n=0; HeaderControl->Sections->Count;n++)
        {
        if (HeaderControl->Sections->Items[n]==Section) break;
        }
if (!StringGrid1->Visible || !n) return;

MobileCodes.SortArrayBuf(StringGrid1->RowCount, n-1);
StringGrid1->Refresh();
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::FormPaint(TObject *Sender)
{
static bool b=true;
if (b && MainForm->Prefs.bSeeAllSaves)
        {
        b=false;
        MainForm->bNoMessageHelp=true;        
        ButtonSearch->Click();
        }
}
//------------------------------------------------------------------------------
void __fastcall TFormMobileCodes::FormDestroy(TObject *Sender)
{
lstrcpy(MainForm->Prefs.szMobile, ComboBox1->Text.c_str());
}
//------------------------------------------------------------------------------
int TFormMobileCodes::SearchNumberSaves(char* cCode)
{
MobileCodes.lpArrayScr[0]=cCode;
MobileCodes.lpArrayScr[1]=cCode;
MobileCodes.lpArrayScr[2]=cCode;
MobileCodes.lpArrayScr[3]=cCode;
MobileCodes.lpArrayScr[4]=cCode;

int i=0;
if (!MobileCodes.bError)
        {
        while (MobileCodes.Find(SEARCH_MOBILE_CODES))
                {
                i++;
                }
        }
return i;
}
//------------------------------------------------------------------------------
